diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-bbr-example.cc ns-3.43/examples/tcp/tcp-bbr-example.cc
--- ns-3.42/examples/tcp/tcp-bbr-example.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-bbr-example.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018-20 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Aarti Nandagiri <aarti.nandagiri@gmail.com>
  *          Vivek Jain <jain.vivek.anand@gmail.com>
@@ -41,7 +30,7 @@
 //     * bbr-3-0.pcap for the first interface on R2
 //     * bbr-3-1.pcap for the second interface on R2
 // (2) cwnd.dat file contains congestion window trace for the sender node
-// (3) throughput.dat file contains sender side throughput trace
+// (3) throughput.dat file contains sender side throughput trace (throughput is in Mbit/s)
 // (4) queueSize.dat file contains queue length trace from the bottleneck link
 //
 // BBR algorithm enters PROBE_RTT phase in every 10 seconds. The congestion
@@ -81,9 +70,12 @@
     {
         auto itr = stats.begin();
         Time curTime = Now();
-        throughput << curTime << " "
+
+        // Convert (curTime - prevTime) to microseconds so that throughput is in bits per
+        // microsecond (which is equivalent to Mbps)
+        throughput << curTime.GetSeconds() << "s "
                    << 8 * (itr->second.txBytes - prev) / ((curTime - prevTime).ToDouble(Time::US))
-                   << std::endl;
+                   << " Mbps" << std::endl;
         prevTime = curTime;
         prev = itr->second.txBytes;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-bulk-send.cc ns-3.43/examples/tcp/tcp-bulk-send.cc
--- ns-3.42/examples/tcp/tcp-bulk-send.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-bulk-send.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 // Network topology
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-large-transfer.cc ns-3.43/examples/tcp/tcp-large-transfer.cc
--- ns-3.42/examples/tcp/tcp-large-transfer.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-large-transfer.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-linux-reno.cc ns-3.43/examples/tcp/tcp-linux-reno.cc
--- ns-3.42/examples/tcp/tcp-linux-reno.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-linux-reno.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Apoorva Bhargava <apoorvabhargava13@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-pacing.cc ns-3.43/examples/tcp/tcp-pacing.cc
--- ns-3.42/examples/tcp/tcp-pacing.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-pacing.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Vivek Jain <jain.vivek.anand@gmail.com>
  *          Deepak Kumaraswamy <deepakkavoor99@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-pcap-nanosec-example.cc ns-3.43/examples/tcp/tcp-pcap-nanosec-example.cc
--- ns-3.42/examples/tcp/tcp-pcap-nanosec-example.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-pcap-nanosec-example.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 // ============================================================ //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-star-server.cc ns-3.43/examples/tcp/tcp-star-server.cc
--- ns-3.42/examples/tcp/tcp-star-server.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-star-server.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-validation.cc ns-3.43/examples/tcp/tcp-validation.cc
--- ns-3.42/examples/tcp/tcp-validation.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-validation.cc	2024-10-09 16:41:09.840655800 -0700
@@ -2,34 +2,7 @@
  * Copyright (c) 2019 Cable Television Laboratories, Inc.
  * Copyright (c) 2020 Tom Henderson (adapted for DCTCP testing)
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions, and the following disclaimer,
- *    without modification.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The names of the authors may not be used to endorse or promote products
- *    derived from this software without specific prior written permission.
- *
- * Alternatively, provided that this notice is retained in full, this
- * software may be distributed under the terms of the GNU General
- * Public License ("GPL") version 2, in which case the provisions of the
- * GPL apply INSTEAD OF those given above.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
- * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
- * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
- * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
- * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
- * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
- * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
- * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ * SPDX-License-Identifier: BSD-3-Clause
  */
 
 // This program is designed to observe long-running TCP congestion control
@@ -258,10 +231,10 @@
             NS_LOG_WARN("now " << Now().As(Time::S) << " alpha " << alpha << " (expected <= 0.1)");
             g_validationFailed = true;
         }
-        if ((now > 7) && ((alpha > 0.09) || (alpha < 0.055)))
+        if ((now > 7) && ((alpha > 0.09) || (alpha < 0.049)))
         {
             NS_LOG_WARN("now " << Now().As(Time::S) << " alpha " << alpha
-                               << " (expected 0.09 <= alpha <= 0.055)");
+                               << " (expected 0.09 <= alpha <= 0.049)");
             g_validationFailed = true;
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tcp/tcp-variants-comparison.cc ns-3.43/examples/tcp/tcp-variants-comparison.cc
--- ns-3.42/examples/tcp/tcp-variants-comparison.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tcp/tcp-variants-comparison.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013 ResiliNets, ITTC, University of Kansas
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Justin P. Rohrer, Truc Anh N. Nguyen <annguyen@ittc.ku.edu>, Siddharth Gangadhar
  * <siddharth@ittc.ku.edu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/CMakeLists.txt ns-3.43/examples/traffic-control/CMakeLists.txt
--- ns-3.42/examples/traffic-control/CMakeLists.txt	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/CMakeLists.txt	2024-10-09 16:41:09.840655800 -0700
@@ -1,6 +1,6 @@
 build_example(
-  NAME traffic-control
-  SOURCE_FILES traffic-control.cc
+  NAME traffic-control-example
+  SOURCE_FILES traffic-control-example.cc
   LIBRARIES_TO_LINK
     ${libinternet}
     ${libpoint-to-point}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/cobalt-vs-codel.cc ns-3.43/examples/traffic-control/cobalt-vs-codel.cc
--- ns-3.42/examples/traffic-control/cobalt-vs-codel.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/cobalt-vs-codel.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Shefali Gupta <shefaligups11@ogmail.com>
  *         Jendaipou Palmei <jendaipoupalmei@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/queue-discs-benchmark.cc ns-3.43/examples/traffic-control/queue-discs-benchmark.cc
--- ns-3.42/examples/traffic-control/queue-discs-benchmark.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/queue-discs-benchmark.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2015 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Pasquale Imputato <p.imputato@gmail.com>
  *          Stefano Avallone <stefano.avallone@unina.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/red-vs-fengadaptive.cc ns-3.43/examples/traffic-control/red-vs-fengadaptive.cc
--- ns-3.42/examples/traffic-control/red-vs-fengadaptive.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/red-vs-fengadaptive.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sourabh Jain <sourabhjain560@outlook.com>
  *         Mohit P. Tahiliani <tahiliani@nitk.edu.in>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/red-vs-nlred.cc ns-3.43/examples/traffic-control/red-vs-nlred.cc
--- ns-3.42/examples/traffic-control/red-vs-nlred.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/red-vs-nlred.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 NITK Surathkal
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Phani Kiran S V S <phanikiran.harithas@gmail.com>
  *          Nichit Bodhak Goel <nichit93@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/tbf-example.cc ns-3.43/examples/traffic-control/tbf-example.cc
--- ns-3.42/examples/traffic-control/tbf-example.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/traffic-control/tbf-example.cc	2024-10-09 16:41:09.840655800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2015 Universita' degli Studi di Napoli "Federico II"
  *               2017 Kungliga Tekniska Högskolan
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Pasquale Imputato <p.imputato@gmail.com>
  * Author: Stefano Avallone <stefano.avallone@unina.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/traffic-control/traffic-control-example.cc ns-3.43/examples/traffic-control/traffic-control-example.cc
--- ns-3.42/examples/traffic-control/traffic-control-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/examples/traffic-control/traffic-control-example.cc	2024-10-09 16:41:09.840655800 -0700
@@ -0,0 +1,237 @@
+/*
+ * Copyright (c) 2015 Universita' degli Studi di Napoli "Federico II"
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Pasquale Imputato <p.imputato@gmail.com>
+ * Author: Stefano Avallone <stefano.avallone@unina.it>
+ */
+
+#include "ns3/applications-module.h"
+#include "ns3/core-module.h"
+#include "ns3/flow-monitor-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/network-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/traffic-control-module.h"
+
+// This simple example shows how to use TrafficControlHelper to install a
+// QueueDisc on a device.
+//
+// The default QueueDisc is a pfifo_fast with a capacity of 1000 packets (as in
+// Linux). However, in this example, we install a RedQueueDisc with a capacity
+// of 10000 packets.
+//
+// Network topology
+//
+//       10.1.1.0
+// n0 -------------- n1
+//    point-to-point
+//
+// The output will consist of all the traced changes in the length of the RED
+// internal queue and in the length of the netdevice queue:
+//
+//    DevicePacketsInQueue 0 to 1
+//    TcPacketsInQueue 7 to 8
+//    TcPacketsInQueue 8 to 9
+//    DevicePacketsInQueue 1 to 0
+//    TcPacketsInQueue 9 to 8
+//
+// plus some statistics collected at the network layer (by the flow monitor)
+// and the application layer. Finally, the number of packets dropped by the
+// queuing discipline, the number of packets dropped by the netdevice and
+// the number of packets requeued by the queuing discipline are reported.
+//
+// If the size of the DropTail queue of the netdevice were increased from 1
+// to a large number (e.g. 1000), one would observe that the number of dropped
+// packets goes to zero, but the latency grows in an uncontrolled manner. This
+// is the so-called bufferbloat problem, and illustrates the importance of
+// having a small device queue, so that the standing queues build in the traffic
+// control layer where they can be managed by advanced queue discs rather than
+// in the device layer.
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("TrafficControlExample");
+
+/**
+ * Number of packets in TX queue trace.
+ *
+ * \param oldValue Old velue.
+ * \param newValue New value.
+ */
+void
+TcPacketsInQueueTrace(uint32_t oldValue, uint32_t newValue)
+{
+    std::cout << "TcPacketsInQueue " << oldValue << " to " << newValue << std::endl;
+}
+
+/**
+ * Packets in the device queue trace.
+ *
+ * \param oldValue Old velue.
+ * \param newValue New value.
+ */
+void
+DevicePacketsInQueueTrace(uint32_t oldValue, uint32_t newValue)
+{
+    std::cout << "DevicePacketsInQueue " << oldValue << " to " << newValue << std::endl;
+}
+
+/**
+ * TC Soujoun time trace.
+ *
+ * \param sojournTime The soujourn time.
+ */
+void
+SojournTimeTrace(Time sojournTime)
+{
+    std::cout << "Sojourn time " << sojournTime.ToDouble(Time::MS) << "ms" << std::endl;
+}
+
+int
+main(int argc, char* argv[])
+{
+    double simulationTime = 10; // seconds
+    std::string transportProt = "Tcp";
+    std::string socketType;
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("transportProt", "Transport protocol to use: Tcp, Udp", transportProt);
+    cmd.Parse(argc, argv);
+
+    if (transportProt == "Tcp")
+    {
+        socketType = "ns3::TcpSocketFactory";
+    }
+    else
+    {
+        socketType = "ns3::UdpSocketFactory";
+    }
+
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    PointToPointHelper pointToPoint;
+    pointToPoint.SetDeviceAttribute("DataRate", StringValue("10Mbps"));
+    pointToPoint.SetChannelAttribute("Delay", StringValue("2ms"));
+    pointToPoint.SetQueue("ns3::DropTailQueue", "MaxSize", StringValue("1p"));
+
+    NetDeviceContainer devices;
+    devices = pointToPoint.Install(nodes);
+
+    InternetStackHelper stack;
+    stack.Install(nodes);
+
+    TrafficControlHelper tch;
+    tch.SetRootQueueDisc("ns3::RedQueueDisc");
+    QueueDiscContainer qdiscs = tch.Install(devices);
+
+    Ptr<QueueDisc> q = qdiscs.Get(1);
+    q->TraceConnectWithoutContext("PacketsInQueue", MakeCallback(&TcPacketsInQueueTrace));
+    Config::ConnectWithoutContext(
+        "/NodeList/1/$ns3::TrafficControlLayer/RootQueueDiscList/0/SojournTime",
+        MakeCallback(&SojournTimeTrace));
+
+    Ptr<NetDevice> nd = devices.Get(1);
+    Ptr<PointToPointNetDevice> ptpnd = DynamicCast<PointToPointNetDevice>(nd);
+    Ptr<Queue<Packet>> queue = ptpnd->GetQueue();
+    queue->TraceConnectWithoutContext("PacketsInQueue", MakeCallback(&DevicePacketsInQueueTrace));
+
+    Ipv4AddressHelper address;
+    address.SetBase("10.1.1.0", "255.255.255.0");
+
+    Ipv4InterfaceContainer interfaces = address.Assign(devices);
+
+    // Flow
+    uint16_t port = 7;
+    Address localAddress(InetSocketAddress(Ipv4Address::GetAny(), port));
+    PacketSinkHelper packetSinkHelper(socketType, localAddress);
+    ApplicationContainer sinkApp = packetSinkHelper.Install(nodes.Get(0));
+
+    sinkApp.Start(Seconds(0.0));
+    sinkApp.Stop(Seconds(simulationTime + 0.1));
+
+    uint32_t payloadSize = 1448;
+    Config::SetDefault("ns3::TcpSocket::SegmentSize", UintegerValue(payloadSize));
+
+    OnOffHelper onoff(socketType, Ipv4Address::GetAny());
+    onoff.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
+    onoff.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0]"));
+    onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
+    onoff.SetAttribute("DataRate", StringValue("50Mbps")); // bit/s
+    ApplicationContainer apps;
+
+    InetSocketAddress rmt(interfaces.GetAddress(0), port);
+    onoff.SetAttribute("Remote", AddressValue(rmt));
+    onoff.SetAttribute("Tos", UintegerValue(0xb8));
+    apps.Add(onoff.Install(nodes.Get(1)));
+    apps.Start(Seconds(1.0));
+    apps.Stop(Seconds(simulationTime + 0.1));
+
+    FlowMonitorHelper flowmon;
+    Ptr<FlowMonitor> monitor = flowmon.InstallAll();
+
+    Simulator::Stop(Seconds(simulationTime + 5));
+    Simulator::Run();
+
+    Ptr<Ipv4FlowClassifier> classifier = DynamicCast<Ipv4FlowClassifier>(flowmon.GetClassifier());
+    std::map<FlowId, FlowMonitor::FlowStats> stats = monitor->GetFlowStats();
+    std::cout << std::endl << "*** Flow monitor statistics ***" << std::endl;
+    std::cout << "  Tx Packets/Bytes:   " << stats[1].txPackets << " / " << stats[1].txBytes
+              << std::endl;
+    std::cout << "  Offered Load: "
+              << stats[1].txBytes * 8.0 /
+                     (stats[1].timeLastTxPacket.GetSeconds() -
+                      stats[1].timeFirstTxPacket.GetSeconds()) /
+                     1000000
+              << " Mbps" << std::endl;
+    std::cout << "  Rx Packets/Bytes:   " << stats[1].rxPackets << " / " << stats[1].rxBytes
+              << std::endl;
+    uint32_t packetsDroppedByQueueDisc = 0;
+    uint64_t bytesDroppedByQueueDisc = 0;
+    if (stats[1].packetsDropped.size() > Ipv4FlowProbe::DROP_QUEUE_DISC)
+    {
+        packetsDroppedByQueueDisc = stats[1].packetsDropped[Ipv4FlowProbe::DROP_QUEUE_DISC];
+        bytesDroppedByQueueDisc = stats[1].bytesDropped[Ipv4FlowProbe::DROP_QUEUE_DISC];
+    }
+    std::cout << "  Packets/Bytes Dropped by Queue Disc:   " << packetsDroppedByQueueDisc << " / "
+              << bytesDroppedByQueueDisc << std::endl;
+    uint32_t packetsDroppedByNetDevice = 0;
+    uint64_t bytesDroppedByNetDevice = 0;
+    if (stats[1].packetsDropped.size() > Ipv4FlowProbe::DROP_QUEUE)
+    {
+        packetsDroppedByNetDevice = stats[1].packetsDropped[Ipv4FlowProbe::DROP_QUEUE];
+        bytesDroppedByNetDevice = stats[1].bytesDropped[Ipv4FlowProbe::DROP_QUEUE];
+    }
+    std::cout << "  Packets/Bytes Dropped by NetDevice:   " << packetsDroppedByNetDevice << " / "
+              << bytesDroppedByNetDevice << std::endl;
+    std::cout << "  Throughput: "
+              << stats[1].rxBytes * 8.0 /
+                     (stats[1].timeLastRxPacket.GetSeconds() -
+                      stats[1].timeFirstRxPacket.GetSeconds()) /
+                     1000000
+              << " Mbps" << std::endl;
+    std::cout << "  Mean delay:   " << stats[1].delaySum.GetSeconds() / stats[1].rxPackets
+              << std::endl;
+    std::cout << "  Mean jitter:   " << stats[1].jitterSum.GetSeconds() / (stats[1].rxPackets - 1)
+              << std::endl;
+    auto dscpVec = classifier->GetDscpCounts(1);
+    for (auto p : dscpVec)
+    {
+        std::cout << "  DSCP value:   0x" << std::hex << static_cast<uint32_t>(p.first) << std::dec
+                  << "  count:   " << p.second << std::endl;
+    }
+
+    Simulator::Destroy();
+
+    std::cout << std::endl << "*** Application statistics ***" << std::endl;
+    double thr = 0;
+    uint64_t totalPacketsThr = DynamicCast<PacketSink>(sinkApp.Get(0))->GetTotalRx();
+    thr = totalPacketsThr * 8 / (simulationTime * 1000000.0); // Mbit/s
+    std::cout << "  Rx Bytes: " << totalPacketsThr << std::endl;
+    std::cout << "  Average Goodput: " << thr << " Mbit/s" << std::endl;
+    std::cout << std::endl << "*** TC Layer statistics ***" << std::endl;
+    std::cout << q->GetStats() << std::endl;
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tutorial/fifth.cc ns-3.43/examples/tutorial/fifth.cc
--- ns-3.42/examples/tutorial/fifth.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tutorial/fifth.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "tutorial-app.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/examples/tutorial/first.cc ns-3.43/examples/tutorial/first.cc
--- ns-3.42/examples/tutorial/first.cc	2024-05-29 15:29:46.912073100 -0700
+++ ns-3.43/examples/tutorial/first.cc	2024-10-09 16:41:09.840655800 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #include "ns3/applications-module.h"
